require('sketchup.rb')

def dbWindopen
dolt = 103.mm
dtwt = 315.mm

prompts = ["Wall external leaf thickness", "Wall total thickness"]
defaults = [ dolt, dtwt]
results = UI.inputbox prompts, defaults, "db Window Opening"
olt = results[0]
twt = results[1]


model = Sketchup.active_model
#ents = model.entities
model.start_operation "dbWindow Opening"
sel = model.selection
if sel[0]==nil
  UI.messagebox "No window components selected", MB_OK
else
sel.grep(Sketchup::ComponentInstance).each{|e|
if e.valid? && e.definition.behavior.is2d?
  gluee = e.glued_to
  if gluee!=nil
    if gluee.is_a? Sketchup::Face
	  glueen = gluee.normal
	  puts glueen
	  ents = model.entities	  
	else
	#UI.messagebox "Need to explode wall group", MB_OK
#=begin
	  ents = gluee.entities
	  ip = e.transformation.origin
	  puts ip
	  gip = gluee.transformation.origin
	  puts gip
	  nip = gip - ip
	  puts nip
	  ents.add_line ([0,0,0], nip)
      ents.each {|f|
      if f.is_a? Sketchup::Face
      clp = f.classify_point ip
	    if clp > 0 && clp < 5
          glueen = f.normal
		  puts glueen
	    end

	  end
      }
#=end	  
	end

	if glueen.y==1.0 || glueen.y==-1.0
    puts gluee
    ip = e.transformation.origin
    bb = e.bounds
    min = bb.min
    max = bb.max
    f1 = [min.x, ip.y, min.z]
    f2 = [max.x, ip.y, min.z]
    f3 = [max.x, ip.y, max.z]
    f4 = [min.x, ip.y, max.z]
    front = ents.add_face(f1, f2, f3, f4)
	fny = front.normal.y
    front.pushpull -olt
    if fny<0
      r1 = [min.x, ip.y+twt, min.z]
      r2 = [max.x, ip.y+twt, min.z]
      r3 = [max.x, ip.y+twt, max.z]
      r4 = [min.x, ip.y+twt, max.z]
      rear = ents.add_face(r1, r2, r3, r4)
	  rear.pushpull -(twt-olt)
  
    else
      r1 = [min.x, ip.y-twt, min.z]
      r2 = [max.x, ip.y-twt, min.z]
      r3 = [max.x, ip.y-twt, max.z]
      r4 = [min.x, ip.y-twt, max.z]
      rear = ents.add_face(r1, r2, r3, r4)
	  rear.pushpull -(twt-olt)  
    end # if fny  
  end # if gluee.y
  
  if glueen.x==1.0 || glueen.x==-1.0
    puts gluee
    ip = e.transformation.origin
    bb = e.bounds
    min = bb.min
    max = bb.max
    f1 = [ip.x, min.y, min.z]
    f2 = [ip.x, max.y, min.z]
    f3 = [ip.x, max.y, max.z]
    f4 = [ip.x, min.y, max.z]
    front = ents.add_face(f1, f2, f3, f4)
	fnx = front.normal.x
    front.pushpull -olt
    if fnx<0
      r1 = [ip.x+twt, min.y, min.z]
      r2 = [ip.x+twt, max.y, min.z]
      r3 = [ip.x+twt, max.y, max.z]
      r4 = [ip.x+twt, min.y, max.z]
      rear = ents.add_face(r1, r2, r3, r4)
	  rear.pushpull -(twt-olt)
  
    else
      r1 = [ip.x-twt, min.y, min.z]
      r2 = [ip.x-twt, max.y, min.z]
      r3 = [ip.x-twt, max.y, max.z]
      r4 = [ip.x-twt, min.y, max.z]
      rear = ents.add_face(r1, r2, r3, r4)
	  rear.pushpull -(twt-olt)  
    end # if fny  
	
  end #if gluee.x
  else
  UI.messagebox "Component not Glued to face", MB_OK

  
  
  end #if gluee!=nil
  
end#if e.valid
}

end

model.commit_operation

end #dbWindopen

if (not file_loaded?("dbWindopen.rb"))
    UI.menu("Plugins").add_item("db Window Opening") { dbWindopen }
end
file_loaded("dbWindopen.rb")